package com.caimei365.tools.mapper;

import com.caimei365.tools.model.po.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2022/11/2
 */
@Mapper
public interface CmBehaviorRecordMapper {

    /**
     * 用户行为记录
     * @param cmBehaviorRecordPo
     * @return
     */
    void insertRecord(CmBehaviorRecordPo cmBehaviorRecordPo);

    /**
     * 当天访问网站IP、userId
     * @param cmBehaviorRecordPo
     */
    List<CmBehaviorRecordPo> toDateRecode(CmBehaviorRecordPo cmBehaviorRecordPo);

    /**
     * 当天访问网站IP、userId的详细数据
     * @param cmBehaviorRecordPo
     */
    List<CmBehaviorRecordPo> toDateIPTimeRecode(CmBehaviorRecordPo cmBehaviorRecordPo);

    /**
     * 计算真是访问时长
     * @param cmBehaviorRecordPo
     */
    void updateDuration(CmBehaviorRecordPo cmBehaviorRecordPo);

    /**
     * 查询所有老数据
     * @return
     */
    List<CmUserPo> findList(@Param("startId") Integer startId, @Param("endId") Integer endId);

    /**
     * 修改老数据ip所在地
     * @param userPo
     */
    void updateOldData(CmUserPo userPo);

    List<CmVipCouponPo> selSvipCoupon(@Param("startTime") String startTime, @Param("endTime") String endTime);

    void updateSvipCoupon(CmVipCouponPo cmVipCouponPo);

    void insertVipCouponMonth(CmVipCouponPo cmVipCouponPo);

    List<CmCouponPo> selCoupon();

    void updateCoupon(CmCouponPo cmCouponPo);

    void insertCoupon(CmCouponPo cmCouponPo);

    Integer selById();

    List<CmCouponAssociatePo> selCouponPro(@Param("couponId") String couponId);

    void insertCouponAssociate(CmCouponAssociatePo associate);

    Integer selSvipCouponById();

    void insertRelation(CmVipCouponRelation cmVipCouponRelation);

    List<CmBehaviorRecordPo> countNum(@Param("accessDate") String accessDate);

    CmBehaviorRecordPo userIdAcc(@Param("IP") String IP, @Param("accessDate") String accessDate);

    List<CmBehaviorRecordPo> selBehaviorList(@Param("IP") String IP, @Param("accessDate") String accessDate);

    void updateBehavior(CmBehaviorRecordPo cmBehaviorRecordPo);

    List<CmBehaviorRecordPo> selYesterdayList(@Param("accessDate") String accessDate);

    /**
     * 插入昨日数据
     * @param cmBehaviorRecordPo
     */
    void insertYesterdayList(CmBehaviorRecordPo cmBehaviorRecordPo);

    /**
     * 查询今日所有用户行为数据
     * @param accessDate
     * @return
     */
    List<CmBehaviorRecordPo> selTodayData(@Param("accessDate") String accessDate);

    /**
     * 关联供应商数据
     * @param accessDate
     * @return
     */
    List<CmBehaviorRecordPo> selDataList(@Param("accessDate") String accessDate);

    /**
     * 将今日数据存储到今日数据表
     * @param cmBehaviorRecordPo 参数
     */
    void inBehaviorToday(CmBehaviorRecordPo cmBehaviorRecordPo);

    /**
     * 清除今日用户数据数据
     */
    void delTodayData();

    /**
     * 查询供应商id
     * @param strList 页面标签
     * @return 返回
     */
    List<Integer> shopIds(@Param("strList") List<String> strList);

    /**
     * 获取是否关联供应商
     * @param ShopId
     * @return
     */
    Integer selShopId(@Param("shopId") Integer ShopId);
    /**
     * 添加惯量供应商
     * @param recordId 用户行为记录id
     * @param shopId 供应商id
     */
    void insertShopId(@Param("recordId") Integer recordId, @Param("shopId") Integer shopId);
}

